SystemOrganization addCategory: #'PocketCube-Tests'!
SystemOrganization addCategory: #'PocketCube-Morph'!
SystemOrganization addCategory: #PocketCube!
SystemOrganization addCategory: #'PocketCube-Recognizer'!
SystemOrganization addCategory: #'PocketCube-SidePatterns'!
SystemOrganization addCategory: #'PocketCube-SidePatterns-Tests'!

Object subclass: #PocketCube
	instanceVariableNames: 'topSide leftSide bottomSide rightSide frontSide backSide'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube'!

!PocketCube methodsFor: 'sides' stamp: 'hjo 1/31/2011 19:16'!
allSides

	^Array streamContents: [:stream| 
		stream nextPut: topSide.
		stream nextPut: leftSide.
		stream nextPut: bottomSide.
		stream nextPut: rightSide.
		stream nextPut: frontSide.
		stream nextPut: backSide  ]! !

!PocketCube methodsFor: 'testing' stamp: 'hjo 1/31/2011 19:14'!
allSidesAreOneColor

	^self allSides allSatisfy: [:each| each isOneColor ] ! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:53'!
arrayOfBackSide

	^Array with: backSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:31'!
backSide

	^backSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:32'!
backSide: aPocketCubeSide 

	backSide := aPocketCubeSide ! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:23'!
bottomSide

	^bottomSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:22'!
bottomSide: aPocketCubeSide 

	bottomSide := aPocketCubeSide ! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:29'!
frontSide

	^frontSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:30'!
frontSide: aPocketCubeSide 

	frontSide := aPocketCubeSide ! !

!PocketCube methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 21:46'!
frontSideBackSideAreOneColor

	^frontSide isOneColor and: [backSide isOneColor]! !

!PocketCube methodsFor: 'initializing' stamp: 'hjo 2/2/2011 18:57'!
initializeSidesWithColors

	self topSide: (PocketCubeSide ofAllSamePieces: Color red).
	self leftSide: (PocketCubeSide ofAllSamePieces: Color white).
	self bottomSide: (PocketCubeSide ofAllSamePieces: Color orange).
	self rightSide: (PocketCubeSide ofAllSamePieces: Color yellow).
	self frontSide: (PocketCubeSide ofAllSamePieces: Color green).
	self backSide: (PocketCubeSide ofAllSamePieces: Color blue).! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:19'!
leftSide

	^leftSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:19'!
leftSide: aPocketCubeSide 

	leftSide := aPocketCubeSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:26'!
rightSide

	^rightSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:27'!
rightSide: aPocketCubeSide 

	rightSide := aPocketCubeSide! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 2/1/2011 18:49'!
rotateClockwise

	self rotateClockwiseForSideAroundFrontFace.
	self rotateSidesClockwise: self sidesWithoutBackSide 
		rotateSidesCounterClockwise: self arrayOfBackSide.
	self triggerEvent: #pocketCubeChanged.! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:43'!
rotateClockwiseForSideAroundFrontFace

	self setSidesTopRightBottomLeft: 
		(Array 
			with: leftSide 
			with: topSide 
			with: rightSide 
			with: bottomSide)
! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 2/1/2011 18:49'!
rotateCounterClockwise

	self rotateCounterClockwiseForSideAroundFrontFace.
	self rotateSidesClockwise: self arrayOfBackSide 
		rotateSidesCounterClockwise: self sidesWithoutBackSide.
	self triggerEvent: #pocketCubeChanged.! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:44'!
rotateCounterClockwiseForSideAroundFrontFace

	self setSidesTopRightBottomLeft:
		(Array
			with: rightSide
			with: bottomSide
			with: leftSide
			with: topSide)! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/26/2010 02:00'!
rotateLeft

	self twistUpperLayerRight.
	self twistLowerLayerRight! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 07:49'!
rotateLeftForSides

	| tempSide |
	tempSide := backSide.
	backSide := rightSide.
	rightSide := frontSide.
	frontSide := leftSide.
	leftSide := tempSide! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/26/2010 02:02'!
rotateRight

	self twistUpperLayerLeft.
	self twistLowerLayerLeft! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 09:44'!
rotateRightForSides

	| tempSide |
	tempSide := leftSide.
	leftSide := frontSide.
	frontSide := rightSide.
	rightSide := backSide.
	backSide := tempSide! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:50'!
rotateSidesClockwise: anArray rotateSidesCounterClockwise: anArray2 

	anArray do: [:each| each rotateClockwise ].
	anArray2 do: [:each| each rotateCounterClockwise ].! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:41'!
setSidesTopRightBottomLeft: anArray

	topSide := anArray at: 1.
	rightSide := anArray at: 2.
	bottomSide := anArray at: 3.
	leftSide := anArray at: 4! !

!PocketCube methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 10:22'!
sideColumn

	^(Array with: topSide with: frontSide with: bottomSide with: self virtualVerticalBackSide)
		collect: [:each| each rotatedCounterClockwisely]! !

!PocketCube methodsFor: 'as yet unclassified' stamp: 'hjo 2/6/2011 19:23'!
sideRow

	^self sidesInOrder! !

!PocketCube methodsFor: 'testing' stamp: 'hjo 2/2/2011 19:30'!
sidesAreUpperLayerTwisted: array1 to: array2

	1 to: 4 do: [:index| 
		(self sidesInOrder at:(array1 at:index)) copyOutLowerLayer = (self sidesInOrder at:(array2 at:index)) copyOutUpperLayer
			ifFalse: [^false].
		].
	^true! !

!PocketCube methodsFor: 'testing' stamp: 'hjo 2/2/2011 19:27'!
sidesAreUpperLayerTwistedLeft

	^self sidesAreUpperLayerTwisted: #(2 3 4 1) to: #(1 2 3 4).! !

!PocketCube methodsFor: 'testing' stamp: 'hjo 2/2/2011 19:27'!
sidesAreUpperLayerTwistedRight

	^self sidesAreUpperLayerTwisted: #(1 2 3 4) to: #(2 3 4 1).! !

!PocketCube methodsFor: 'testing' stamp: 'hjo 2/2/2011 19:28'!
sidesAreUpperLayerTwistedTwice

	^self sidesAreUpperLayerTwisted: #(1 2 3 4) to: #(3 4 1 2).! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 7/17/2010 22:38'!
sidesInOrder

	^Array with: leftSide with: frontSide with: rightSide with:backSide! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 2/1/2011 21:57'!
sidesReverseOrder

	^self sidesInOrder reversed! !

!PocketCube methodsFor: 'rotate' stamp: 'hjo 7/18/2010 22:55'!
sidesWithoutBackSide
	
	^Array with: frontSide with: topSide with: leftSide with: rightSide with: bottomSide! !

!PocketCube methodsFor: 'testing' stamp: 'hjo 2/1/2011 18:46'!
slidesAreVerticallyLayerTwisted

	self rotateClockwise.
	[self sidesAreUpperLayerTwistedLeft ifTrue: [^true].
	self sidesAreUpperLayerTwistedRight ifTrue: [^true].
	self sidesAreUpperLayerTwistedTwice ifTrue: [^true].
	^false] ensure: [self rotateCounterClockwise].
	! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:15'!
topSide

	^topSide! !

!PocketCube methodsFor: 'sides' stamp: 'hjo 7/17/2010 20:15'!
topSide: aPocketCubeSide 

	topSide := aPocketCubeSide! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 2/1/2011 18:47'!
twistLowerLayerLeft

	bottomSide rotateCounterClockwise.
	self twistLowerLayerWithSides: self sidesInOrder.
	self triggerEvent: #pocketCubeChanged.! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 2/1/2011 12:57'!
twistLowerLayerRight

	bottomSide rotateClockwise.
	self twistLowerLayerWithSides: self sidesReverseOrder.
	self triggerEvent: #pocketCubeChanged! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 7/17/2010 22:32'!
twistLowerLayerWithSides: anArray 

	| twoPieces |
	twoPieces := (anArray at:1) copyOutLowerLayer.
	(anArray at:1) copyInLowerLayer: (anArray at:2) copyOutLowerLayer.
	(anArray at:2) copyInLowerLayer: (anArray at:3) copyOutLowerLayer.
	(anArray at:3) copyInLowerLayer: (anArray at:4) copyOutLowerLayer.
	(anArray at:4) copyInLowerLayer: twoPieces! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 2/1/2011 18:48'!
twistUpperLayerLeft

	topSide rotateClockwise.
	self twistUpperLayerWithSides: self sidesInOrder.
	self triggerEvent: #pocketCubeChanged.! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 2/1/2011 18:48'!
twistUpperLayerRight

	topSide rotateCounterClockwise.
	self twistUpperLayerWithSides: self sidesReverseOrder.
	self triggerEvent: #pocketCubeChanged.! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 7/17/2010 22:31'!
twistUpperLayerWithSides: anArray 

	| twoPieces |
	twoPieces := (anArray at:1) copyOutUpperLayer.
	(anArray at:1) copyInUpperLayer: (anArray at:2) copyOutUpperLayer.
	(anArray at:2) copyInUpperLayer: (anArray at:3) copyOutUpperLayer.
	(anArray at:3) copyInUpperLayer: (anArray at:4) copyOutUpperLayer.
	(anArray at:4) copyInUpperLayer: twoPieces! !

!PocketCube methodsFor: 'twist' stamp: 'hjo 2/3/2011 15:05'!
verticalSides

	^Array with: topSide with: frontSide  with: bottomSide  with: backSide! !

!PocketCube methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 21:12'!
virtualVerticalBackSide

	^PocketCubeSide upperLeftPiece: backSide lowerRightPiece upperRightPiece: backSide lowerLeftPiece  lowerLeftPiece: backSide upperRightPiece  lowerRightPiece: backSide upperLeftPiece
	! !

Object subclass: #PocketCubeController
	instanceVariableNames: 'model frontSideController topSideController bottomSideController leftSideController rightSideController backSideController virtualVerticalBackSideController gameMorph moveCubeSound'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Morph'!

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 11:59'!
beScrambled: aSmallInteger

	(PocketCubeScrambler new netStyleScrambleSequenceOf: aSmallInteger) do: [:each| self perform: each]! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 12:38'!
deleteMorph

	gameMorph delete! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 12:38'!
focused

	ActiveHand keyboardFocus: gameMorph! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 10:26'!
horizontalRowY

	^145! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 10:26'!
initialize

	super initialize.
	self initializeModel.
	gameMorph := PocketCubeGameMorph new.
	gameMorph controller: self.
		
	frontSideController := self makeSideControllerWithSelector: #frontSide atOrigin: self verticalColumnX@self horizontalRowY.
	topSideController := self makeSideControllerWithSelector: #topSide atOrigin: self verticalColumnX@55.
	bottomSideController := self makeSideControllerWithSelector: #bottomSide atOrigin: self verticalColumnX@235.
	leftSideController := self makeSideControllerWithSelector: #leftSide atOrigin: 50@self horizontalRowY.
	rightSideController := self makeSideControllerWithSelector: #rightSide atOrigin: 230@self horizontalRowY.
	backSideController := self makeSideControllerWithSelector: #backSide atOrigin: 320@self horizontalRowY.
	virtualVerticalBackSideController := self makeVirtualSideControllerWithSelector: #virtualVerticalBackSide atOrigin: self verticalColumnX@325.

	moveCubeSound := SampledSound fromAIFFfileNamed: 'cube-move.aiff'.! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 18:56'!
initializeModel

	model := PocketCube new.
	model when: #pocketCubeChanged send: #refreshMorph to: self. 
	model initializeSidesWithColors.! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/6/2011 13:03'!
makeSideControllerWithSelector: aSymbol atOrigin: aPoint

	^PocketCubeSideController openMorphOn: model sideAccessor: aSymbol atOrigin: aPoint gameMorph: gameMorph.! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/6/2011 13:09'!
makeVirtualSideControllerWithSelector: aByteSymbol atOrigin: aPoint 

	^PocketCubeVirtualSideController openMorphOn: model sideAccessor: aByteSymbol atOrigin: aPoint gameMorph: gameMorph.! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 15:29'!
model: aPocketCube 

	model removeActionsWithReceiver: self.
	model := aPocketCube.
	model when: #pocketCubeChanged send: #refreshMorph to: self. 
	topSideController pocketCube: model.
	bottomSideController pocketCube: model.
	leftSideController pocketCube: model.
	rightSideController pocketCube: model.
	backSideController pocketCube: model.
	virtualVerticalBackSideController pocketCube: model.
	self refreshMorph.! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 20:49'!
playSoundMoveCube

	moveCubeSound play.! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 12:38'!
position: aPoint 

	gameMorph position: aPoint! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 15:29'!
refreshMorph

	frontSideController refreshMorph.
	backSideController refreshMorph.
	leftSideController refreshMorph.
	rightSideController refreshMorph.
	topSideController refreshMorph.
	bottomSideController refreshMorph.
	virtualVerticalBackSideController refreshMorph.! !

!PocketCubeController methodsFor: 'rotate' stamp: 'hjo 2/1/2011 21:44'!
rotateClockwise
	
	model rotateClockwise.! !

!PocketCubeController methodsFor: 'rotate' stamp: 'hjo 2/1/2011 21:45'!
rotateCounterClockwise

	model rotateCounterClockwise.! !

!PocketCubeController methodsFor: 'rotate' stamp: 'hjo 2/1/2011 21:45'!
rotateLeft
	model rotateLeft.! !

!PocketCubeController methodsFor: 'rotate' stamp: 'hjo 2/1/2011 21:46'!
rotateRight

	model rotateRight.! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 12:38'!
setControllerForGameMorph
	
	gameMorph controller: self! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 1/31/2011 19:04'!
solve

	| recog |
	recog := PocketCubeRecognizer on: model.
	^recog! !

!PocketCubeController methodsFor: 'twist' stamp: 'hjo 2/5/2011 20:48'!
twistLowerLayerLeft

	model twistLowerLayerLeft.
	self playSoundMoveCube.! !

!PocketCubeController methodsFor: 'twist' stamp: 'hjo 2/5/2011 20:48'!
twistLowerLayerRight

	model twistLowerLayerRight.
	self playSoundMoveCube.! !

!PocketCubeController methodsFor: 'twist' stamp: 'hjo 2/5/2011 20:48'!
twistUpperLayerLeft

	model twistUpperLayerLeft.
	self playSoundMoveCube.! !

!PocketCubeController methodsFor: 'twist' stamp: 'hjo 2/5/2011 20:48'!
twistUpperLayerRight

	model twistUpperLayerRight.
	self playSoundMoveCube.! !

!PocketCubeController methodsFor: 'as yet unclassified' stamp: 'hjo 2/6/2011 13:12'!
verticalColumnX

	^140! !

Object subclass: #PocketCubePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

PocketCubePattern subclass: #PocketCube0000Pattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCube0000Pattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/20/2011 13:52'!
isPatternOf: aPocketCube 

	^aPocketCube frontSide sidePattern class = TopBarSidePattern and: [
	aPocketCube rightSide sidePattern class =  BottomBarSidePattern and: [
	aPocketCube leftSide upperLeftPiece = aPocketCube frontSide lowerLeftPiece and: [
	aPocketCube rightSide upperRightPiece = aPocketCube backSide lowerRightPiece] ]]! !

!PocketCube0000Pattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/20/2011 13:53'!
oneStepBetterFor: aPocketCube 

	aPocketCube twistLowerLayerLeft! !

PocketCubePattern subclass: #PocketCubeComplicatedPattern2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeComplicatedPattern2 classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 14:45'!
isPatternOf: aPocketCube 

	| blueColor greenColor redColor orangColor |
	blueColor := aPocketCube leftSide lowerLeftPiece.
	greenColor := aPocketCube frontSide upperLeftPiece.
	redColor := aPocketCube rightSide lowerLeftPiece.
	orangColor := aPocketCube backSide upperLeftPiece.
	
	aPocketCube leftSide lowerRightPiece = blueColor
		ifFalse: [^false].
	aPocketCube frontSide lowerRightPiece = blueColor
		ifFalse: [^false].
	aPocketCube rightSide upperRightPiece = blueColor
		ifFalse: [^false].
	aPocketCube leftSide upperLeftPiece = greenColor
		ifFalse: [^false].	
	aPocketCube frontSide upperRightPiece = greenColor
		ifFalse: [^false].	
	aPocketCube backSide lowerLeftPiece = greenColor
		ifFalse: [^false].	
	aPocketCube leftSide upperRightPiece = redColor
		ifFalse: [^false].		
	aPocketCube rightSide lowerRightPiece = redColor
		ifFalse: [^false].		
	aPocketCube backSide lowerRightPiece = redColor
		ifFalse: [^false].	
	aPocketCube frontSide lowerLeftPiece = orangColor
		ifFalse: [^false].		
	aPocketCube rightSide upperLeftPiece = orangColor
		ifFalse: [^false].		
	aPocketCube backSide upperRightPiece = orangColor
		ifFalse: [^false].		^true! !

!PocketCubeComplicatedPattern2 classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 14:47'!
oneStepBetterFor: aPocketCube 

	aPocketCube twistUpperLayerLeft! !

PocketCubePattern subclass: #PocketCubeComplicatedUpperLayerTwistedPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeComplicatedUpperLayerTwistedPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 14:05'!
isPatternOf: aPocketCube 

	| color1 color2 |
	aPocketCube frontSide copyOutLowerLayer = aPocketCube rightSide copyOutUpperLayer 		ifFalse: [^false].
	color1 := aPocketCube frontSide copyOutLowerLayer first.
	color2 := aPocketCube frontSide copyOutLowerLayer second.
	aPocketCube leftSide copyOutUpperLayer = (Array with: color1 with: color1)
		ifFalse: [^false].
	aPocketCube backSide copyOutLowerLayer = (Array with: color2 with: color2)
		ifFalse: [^false].
	^true! !

!PocketCubeComplicatedUpperLayerTwistedPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 14:05'!
oneStepBetterFor: aPocketCube 

	aPocketCube twistLowerLayerRight.! !

PocketCubePattern subclass: #PocketCubeCounterRotaryBarPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeCounterRotaryBarPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/20/2011 15:26'!
isPatternOf: aPocketCube 

	^aPocketCube topSide lowerLeftPiece = aPocketCube leftSide lowerLeftPiece and: [
	aPocketCube topSide lowerRightPiece = aPocketCube leftSide upperLeftPiece and: [
	aPocketCube leftSide upperRightPiece = aPocketCube bottomSide lowerLeftPiece and: [
	aPocketCube leftSide lowerRightPiece = aPocketCube bottomSide lowerRightPiece and: [
	aPocketCube bottomSide upperLeftPiece  = aPocketCube rightSide lowerRightPiece and: [
	aPocketCube bottomSide upperRightPiece = aPocketCube rightSide upperRightPiece and: [
	aPocketCube rightSide lowerLeftPiece = aPocketCube topSide upperRightPiece and: [
	aPocketCube rightSide upperLeftPiece = aPocketCube topSide upperLeftPiece ]]]]]]]! !

!PocketCubeCounterRotaryBarPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/20/2011 15:28'!
oneStepBetterFor: aPocketCube 

	aPocketCube rotateRight! !

PocketCubePattern subclass: #PocketCubeFrontSideBackSideOneColorPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeFrontSideBackSideOneColorPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 11:58'!
isPatternOf: aPocketCube 

	^aPocketCube frontSideBackSideAreOneColor! !

!PocketCubeFrontSideBackSideOneColorPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 21:47'!
oneStepBetterFor: aPocketCube 

	aPocketCube rotateRight.! !

PocketCubePattern subclass: #PocketCubeLowerTwistedLeftOnRotaryBarPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeLowerTwistedLeftOnRotaryBarPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/20/2011 15:14'!
isPatternOf: aPocketCube 

	^aPocketCube backSide lowerLeftPiece = aPocketCube topSide lowerLeftPiece and: [
	aPocketCube leftSide upperLeftPiece = aPocketCube topSide lowerRightPiece and: [
	aPocketCube topSide upperLeftPiece = aPocketCube rightSide upperLeftPiece and: [
	aPocketCube topSide upperRightPiece = aPocketCube frontSide lowerLeftPiece and: [
	aPocketCube rightSide upperRightPiece = aPocketCube bottomSide upperLeftPiece and: [
	aPocketCube frontSide lowerRightPiece = aPocketCube bottomSide lowerLeftPiece and: [
	aPocketCube bottomSide upperRightPiece = aPocketCube backSide lowerRightPiece and: [
	aPocketCube bottomSide lowerRightPiece = aPocketCube leftSide upperRightPiece ]]]]]]]
	
! !

!PocketCubeLowerTwistedLeftOnRotaryBarPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/20/2011 15:14'!
oneStepBetterFor: aPocketCube 

	aPocketCube twistLowerLayerRight.! !

PocketCubePattern subclass: #PocketCubeOrder3Case1Pattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeOrder3Case1Pattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 19:15'!
isPatternOf: aPocketCube 

	| leftPattern frontPattern rightPattern backPattern ifFalseQuit |
	ifFalseQuit := [:bool | bool ifFalse: [^false]].
	
	leftPattern := aPocketCube leftSide sidePattern.
	frontPattern := aPocketCube frontSide sidePattern.
	rightPattern := aPocketCube rightSide sidePattern.
	backPattern := aPocketCube backSide sidePattern.
	
	ifFalseQuit value: (leftPattern isKindOf: LeftBarSidePattern).
	ifFalseQuit value: (frontPattern isKindOf: RightBarSidePattern).
	ifFalseQuit value: (rightPattern isKindOf: LeftBarSidePattern).
	ifFalseQuit value: (backPattern isKindOf: RightBarSidePattern).
	
	ifFalseQuit value: (leftPattern barColor = backPattern colorOfRightToTheBar).
	ifFalseQuit value: (frontPattern colorOfRightToTheBar = rightPattern barColor).
	^true! !

!PocketCubeOrder3Case1Pattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 19:16'!
oneStepBetterFor: aPocketCube 

	aPocketCube rotateLeft.! !

PocketCubePattern subclass: #PocketCubeOrder3Case2Pattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeOrder3Case2Pattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 19:40'!
isPatternOf: aPocketCube 

	| topPattern frontPattern bottomPattern virtualBackPattern |
	topPattern := aPocketCube topSide sidePattern.
	frontPattern := aPocketCube frontSide sidePattern.
	bottomPattern := aPocketCube bottomSide sidePattern.
	virtualBackPattern := aPocketCube virtualVerticalBackSide sidePattern.
	
	^{
		[frontPattern isLeftBar] .
		[virtualBackPattern isRightBar] .
		[frontPattern colorOfRightToTheBar = virtualBackPattern colorOfLeftToTheBar] .
		[frontPattern colorOfLeftToTheBar = virtualBackPattern colorOfRightToTheBar]
	}
		allSatisfy: [:block| block value ]! !

!PocketCubeOrder3Case2Pattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 19:42'!
oneStepBetterFor: aPocketCube 

	aPocketCube perform: self selectorForOneStepBetter! !

!PocketCubeOrder3Case2Pattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 19:41'!
selectorForOneStepBetter

	^#rotateCounterClockwise! !

PocketCubePattern subclass: #PocketCubePatternFor1UnifiedSideAnd3VertiallyParallelSides
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubePatternFor1UnifiedSideAnd3VertiallyParallelSides classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 13:25'!
isPatternOf: aPocketCube 

	|sidePatterns|
	sidePatterns := aPocketCube verticalSides collect: [:each| each sidePattern].
	^(sidePatterns count: [:each| each isParallelPattern ]) = 4! !

!PocketCubePatternFor1UnifiedSideAnd3VertiallyParallelSides classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 15:52'!
oneStepBetterFor: aPocketCube 

	aPocketCube rotateClockwise ! !

PocketCubePattern subclass: #PocketCubeRotaryBarPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeRotaryBarPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/20/2011 14:16'!
isPatternOf: aPocketCube 

	^aPocketCube topSide lowerLeftPiece = aPocketCube rightSide upperRightPiece and: [
	aPocketCube topSide lowerRightPiece = aPocketCube rightSide lowerRightPiece and: [
	aPocketCube rightSide upperLeftPiece = aPocketCube bottomSide lowerRightPiece and: [
	aPocketCube rightSide lowerLeftPiece = aPocketCube bottomSide lowerLeftPiece and: [
	aPocketCube bottomSide upperLeftPiece = aPocketCube leftSide upperLeftPiece and: [
	aPocketCube bottomSide upperRightPiece = aPocketCube leftSide lowerLeftPiece and: [
	aPocketCube leftSide upperRightPiece = aPocketCube topSide upperRightPiece and: [
	aPocketCube leftSide lowerRightPiece = aPocketCube topSide upperLeftPiece ]]]]]]]! !

!PocketCubeRotaryBarPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/20/2011 14:17'!
oneStepBetterFor: aPocketCube 

	aPocketCube rotateRight.
	aPocketCube rotateCounterClockwise.! !

PocketCubePattern subclass: #PocketCubeSolvedPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeSolvedPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 23:55'!
isPatternOf: aPocketCube 

	^aPocketCube allSidesAreOneColor! !

!PocketCubeSolvedPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 12:56'!
oneStepBetterFor: aPocketCube 

	"do nothing"! !

PocketCubePattern subclass: #PocketCubeUnknownPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeUnknownPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:23'!
oneStepBetterFor: aPocketCube 

	self error: 'i do not know what to do. 
	please, 
		check #scanPattern.
		define new pattern class.'.! !

PocketCubePattern subclass: #PocketCubeUpperLayerTwistedLeftPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeUpperLayerTwistedLeftPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 00:01'!
isPatternOf: aPocketCube 

	^aPocketCube sidesAreUpperLayerTwistedLeft! !

!PocketCubeUpperLayerTwistedLeftPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:18'!
oneStepBetterFor: aPocketCube 

	aPocketCube twistUpperLayerRight! !

PocketCubePattern subclass: #PocketCubeUpperLayerTwistedRightPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeUpperLayerTwistedRightPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 00:02'!
isPatternOf: aPocketCube 
	
	^aPocketCube sidesAreUpperLayerTwistedRight! !

!PocketCubeUpperLayerTwistedRightPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:12'!
oneStepBetterFor: aPocketCube 

	aPocketCube twistUpperLayerLeft! !

PocketCubePattern subclass: #PocketCubeUpperLayerTwistedTwicePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeUpperLayerTwistedTwicePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 00:03'!
isPatternOf: aPocketCube 

	^aPocketCube sidesAreUpperLayerTwistedTwice! !

!PocketCubeUpperLayerTwistedTwicePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:28'!
oneStepBetterFor: aPocketCube 

	2 timesRepeat: [aPocketCube twistUpperLayerRight]! !

PocketCubePattern subclass: #PocketCubeVerticallyLayerTwistedPattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeVerticallyLayerTwistedPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 00:04'!
isPatternOf: aPocketCube 

	^aPocketCube slidesAreVerticallyLayerTwisted! !

!PocketCubeVerticallyLayerTwistedPattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 18:56'!
oneStepBetterFor: aPocketCube 

	aPocketCube rotateCounterClockwise.! !

Object subclass: #PocketCubeRecognizer
	instanceVariableNames: 'pocketCube pattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Recognizer'!

!PocketCubeRecognizer classSide methodsFor: 'as yet unclassified' stamp: 'hjo 1/31/2011 19:05'!
on: aPocketCube 

	|instance|
	instance := self new.
	instance pocketCube: aPocketCube.
	^instance.! !

!PocketCubeRecognizer methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 12:54'!
oneStepBetter

	self scanPattern.
	self oneStepBetterWithPattern.
	pocketCube triggerEvent: #pocketCubeChanged! !

!PocketCubeRecognizer methodsFor: 'as yet unclassified' stamp: 'hjo 2/1/2011 12:57'!
oneStepBetterWithPattern

	pattern oneStepBetterFor: pocketCube.! !

!PocketCubeRecognizer methodsFor: 'accessing' stamp: 'hjo 2/2/2011 23:58'!
pattern: aClass 

	pattern := aClass! !

!PocketCubeRecognizer methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 12:11'!
patternFound

	^pattern notNil! !

!PocketCubeRecognizer methodsFor: 'accessing' stamp: 'hjo 2/1/2011 12:53'!
pocketCube: aPocketCube 

	pocketCube := aPocketCube.! !

!PocketCubeRecognizer methodsFor: 'as yet unclassified' stamp: 'hjo 2/20/2011 15:18'!
scanPattern

	pattern := nil.
	self scanPattern: PocketCubeSolvedPattern.
	self scanPattern: PocketCubeUpperLayerTwistedLeftPattern.
	self scanPattern: PocketCubeUpperLayerTwistedRightPattern.
	self scanPattern: PocketCubeUpperLayerTwistedTwicePattern.
	self scanPattern: PocketCubeVerticallyLayerTwistedPattern.
	self scanPattern: PocketCubeFrontSideBackSideOneColorPattern.
	self scanPattern: PocketCubeComplicatedUpperLayerTwistedPattern.
	self scanPattern: PocketCubeComplicatedPattern2.
	self scanPattern: PocketCubePatternFor1UnifiedSideAnd3VertiallyParallelSides.
	self scanPattern: PocketCubeOrder3Case1Pattern.
	self scanPattern: PocketCubeOrder3Case2Pattern.
	self scanPattern: PocketCube0000Pattern.
	self scanPattern: PocketCubeRotaryBarPattern.
	self scanPattern: PocketCubeCounterRotaryBarPattern.
	self scanPattern: PocketCubeLowerTwistedLeftOnRotaryBarPattern.
	pattern ifNil: [pattern := PocketCubeUnknownPattern].
	^pattern! !

!PocketCubeRecognizer methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 12:01'!
scanPattern: aPattern

	self patternFound ifFalse: [
		(aPattern isPatternOf: pocketCube) ifTrue: [self pattern: aPattern]].! !

Object subclass: #PocketCubeScrambleOperation
	instanceVariableNames: 'amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube'!

!PocketCubeScrambleOperation methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 12:15'!
amount 

	^amount! !

!PocketCubeScrambleOperation methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 12:15'!
amount: anInteger

	amount := anInteger! !

!PocketCubeScrambleOperation methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:30'!
operations

	^Array streamContents: [:stream|
		stream nextPutAll: (self preoperations).
		stream nextPutAll: (self twistOperations).
		stream nextPutAll: (self postoperations).
		].! !

!PocketCubeScrambleOperation methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:31'!
sameTypeWith: aScramble

	^self isKindOf: aScramble class! !

!PocketCubeScrambleOperation methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 12:27'!
setRandomAmount

	amount := #(1 2 -1) atRandom.! !

!PocketCubeScrambleOperation methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:14'!
twistOperations

	^Array streamContents: [:stream|
		self amount abs timesRepeat: [
				stream nextPut: self twistSelector].]! !

PocketCubeScrambleOperation subclass: #ScrambleX
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube'!

!ScrambleX methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:09'!
postoperations

	^#()! !

!ScrambleX methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:05'!
preoperations

	^#()! !

!ScrambleX methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:15'!
twistSelector

	^amount > 0 ifTrue: [#twistLowerLayerLeft] ifFalse: [#twistLowerLayerRight].! !

PocketCubeScrambleOperation subclass: #ScrambleY
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube'!

!ScrambleY methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:10'!
postoperations

	^#(#rotateClockwise)
! !

!ScrambleY methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:06'!
preoperations

	^#(#rotateCounterClockwise)! !

!ScrambleY methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:16'!
twistSelector
	^amount > 0 ifTrue: [#twistUpperLayerRight] ifFalse: [#twistUpperLayerLeft].! !

PocketCubeScrambleOperation subclass: #ScrambleZ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube'!

!ScrambleZ methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:10'!
postoperations

	^#(#rotateClockwise #rotateLeft)
! !

!ScrambleZ methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:06'!
preoperations

	^#(#rotateRight #rotateCounterClockwise).		! !

!ScrambleZ methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:16'!
twistSelector
	^amount > 0 ifTrue: [#twistLowerLayerLeft] ifFalse: [#twistLowerLayerRight]! !

Object subclass: #PocketCubeScrambler
	instanceVariableNames: 'sequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube'!

!PocketCubeScrambler methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:42'!
applyTo: aPocketCube

	self translateSequenceToNetStyle do: [:each| aPocketCube perform: each]! !

!PocketCubeScrambler methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 18:39'!
inverseOperationOf: aByteSymbol 

	aByteSymbol = #twistLowerLayerLeft
		ifTrue: [^#twistLowerLayerRight].
	aByteSymbol = #rotateClockwise
		ifTrue: [^#rotateCounterClockwise].
	aByteSymbol = #twistUpperLayerRight
		ifTrue: [^#twistUpperLayerLeft].
	aByteSymbol = #rotateCounterClockwise
		ifTrue: [^#rotateClockwise].
	aByteSymbol = #rotateLeft
		ifTrue: [^#rotateRight].
	aByteSymbol = #rotateRight
		ifTrue: [^#rotateLeft].
	aByteSymbol = #twistUpperLayerLeft
		ifTrue: [^#twistUpperLayerRight].
	aByteSymbol = #twistLowerLayerRight
		ifTrue: [^#twistLowerLayerLeft].
	self error: 'uncovered case.'! !

!PocketCubeScrambler methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 12:08'!
netStyleScrambleSequenceOf: anInteger

	self scrambleSequenceOf: anInteger.
	^self translateSequenceToNetStyle! !

!PocketCubeScrambler methodsFor: 'as yet unclassified' stamp: 'hjo 7/6/2010 09:01'!
printOnTranscriptScrambleSequenceOf: anInteger

	Transcript show: (self scrambleSequenceOf: anInteger); cr; flush! !

!PocketCubeScrambler methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 18:45'!
printScramblingCode

	^String streamContents: [:stream| 
		self translateSequenceToNetStyle do: [:selector| 
			stream tab; tab; nextPutAll: selector; nextPut: $;; cr 
			]
		]! !

!PocketCubeScrambler methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 18:31'!
rollbackTo: aPocketCube

	self translateSequenceToNetStyle reverseDo: [:each| aPocketCube perform: (self inverseOperationOf: each)]! !

!PocketCubeScrambler methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:29'!
scrambleSequenceOf: anInteger

	| d s randomScramble |
	d := PocketCubeScrambleOperation subclasses.

	s := OrderedCollection new.

	anInteger timesRepeat: [
		[
			randomScramble := d atRandom new.
			randomScramble setRandomAmount.
			s isEmpty not and: [s last sameTypeWith: randomScramble]
		] whileTrue.
		s add: randomScramble.
	].
	^sequence := s asArray! !

!PocketCubeScrambler methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:23'!
translateSequenceToNetStyle

	| code |
	^Array streamContents: [:stream|
		sequence do: [:each| stream nextPutAll: each operations]
		]
	
! !

Object subclass: #PocketCubeSide
	instanceVariableNames: 'upperLeftPiece upperRightPiece lowerRightPiece lowerLeftPiece'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube'!

!PocketCubeSide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 00:47'!
ofAllSamePieces: aColor 

	^self upperLeftPiece: aColor upperRightPiece: aColor lowerLeftPiece: aColor lowerRightPiece: aColor ! !

!PocketCubeSide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:45'!
upperLeftPiece: aSmallInteger upperRightPiece: aSmallInteger2 lowerLeftPiece: aSmallInteger3 lowerRightPiece: aSmallInteger4 

	| instance |
	instance := self new.
	instance upperLeftPiece: aSmallInteger.
	instance upperRightPiece: aSmallInteger2.
	instance lowerLeftPiece: aSmallInteger3.
	instance lowerRightPiece: aSmallInteger4.
	^instance! !

!PocketCubeSide methodsFor: 'comparing' stamp: 'hjo 7/18/2010 01:29'!
= other

	^self equalityComparison of: self and: other! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 20:03'!
copyInLowerLayer: anArray 

	lowerLeftPiece := anArray first.
	lowerRightPiece := anArray second! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:58'!
copyInUpperLayer: anArray 

	upperLeftPiece := anArray first.
	upperRightPiece := anArray second! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:55'!
copyOutLowerLayer

	^Array with: lowerLeftPiece with: lowerRightPiece! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:53'!
copyOutUpperLayer

	^Array with: upperLeftPiece with: upperRightPiece! !

!PocketCubeSide methodsFor: 'comparing' stamp: 'hjo 7/18/2010 01:28'!
equalityComparison

	^EqualityComparison new selectors: #(upperLeftPiece upperRightPiece lowerLeftPiece lowerRightPiece)! !

!PocketCubeSide methodsFor: 'comparing' stamp: 'hjo 7/18/2010 01:33'!
hash

	^self equalityComparison hashOf: self! !

!PocketCubeSide methodsFor: 'testing' stamp: 'hjo 1/31/2011 19:13'!
isOneColor

	^(Set with: upperLeftPiece with: upperRightPiece with: lowerLeftPiece with: lowerRightPiece) size = 1! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:44'!
lowerLeftPiece

	^lowerLeftPiece! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:44'!
lowerLeftPiece: aSmallInteger 
	lowerLeftPiece := aSmallInteger ! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:32'!
lowerRightPiece

	^lowerRightPiece! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:30'!
lowerRightPiece: aSmallInteger 

	lowerRightPiece := aSmallInteger ! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 21:51'!
pieceSet

	^Set with: upperLeftPiece with: upperRightPiece with: lowerLeftPiece with: lowerRightPiece.! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:56'!
printPieces

	^String streamContents: [:stream|
		stream print: upperLeftPiece.
		stream space.
		stream print: upperRightPiece.
		stream cr.
		stream print: lowerLeftPiece.
		stream space.
		stream print: lowerRightPiece]! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:43'!
rotateClockwise

	|temp|
	temp := lowerLeftPiece.
	lowerLeftPiece := lowerRightPiece.
	lowerRightPiece := upperRightPiece.
	upperRightPiece := upperLeftPiece.
	upperLeftPiece := temp.
	! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:48'!
rotateCounterClockwise

	| temp |
	temp := upperLeftPiece.
	upperLeftPiece := upperRightPiece.
	upperRightPiece := lowerRightPiece.
	lowerRightPiece := lowerLeftPiece.
	lowerLeftPiece := temp! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 10:20'!
rotatedCounterClockwisely

	^self species 
		upperLeftPiece: upperRightPiece  upperRightPiece: lowerRightPiece
		lowerLeftPiece: upperLeftPiece lowerRightPiece: lowerLeftPiece! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 13:32'!
sidePattern

	#(UnifiedSidePattern BottomBarSidePattern #VerticallyParallelSidePattern LeftBarSidePattern RightBarSidePattern TopBarSidePattern BottomLeftLSidePattern HorizontallyParallelSidePattern BottomRightLSidePattern TopLeftLSidePattern TopRightLSidePattern FourColorSidePattern) do: [:each| | pattern |
			pattern := (Smalltalk at: each) for: self.
			pattern ifNotNil: [^pattern]].
	^nil! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:31'!
upperLeftPiece

	^upperLeftPiece! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:29'!
upperLeftPiece: aSmallInteger 

	upperLeftPiece := aSmallInteger ! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:31'!
upperRightPiece

	^upperRightPiece! !

!PocketCubeSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:29'!
upperRightPiece: aSmallInteger 

	upperRightPiece := aSmallInteger ! !

Object subclass: #PocketCubeSideController
	instanceVariableNames: 'pocketCube sideAccessor upperLeftPieceMorph upperRightPieceMorph lowerRightPieceMorph lowerLeftPieceMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Morph'!

!PocketCubeSideController classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 19:44'!
openMorphOn: aPocketCube sideAccessor: aByteSymbol atOrigin: aPoint gameMorph: gameMorph 

	| instance |
	instance := self new.
	instance pocketCube: aPocketCube.
	instance sideAccessor: aByteSymbol.
	instance openMorphAtOrigin: aPoint gameMorph: gameMorph.
	instance refreshMorph.
	^instance! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 01:35'!
openBorderedRectangleMorph

	| morph | 
	morph := RectangleMorph new.
	morph borderWidth: 2.
	morph extent: 40@40.
	^morph! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 12:52'!
openMorphAtOrigin: aPoint gameMorph: gameMorph 

	upperLeftPieceMorph := self openMorphAtOrigin: aPoint gameMorph: gameMorph pieceOffset: 0@0 color: self pocketCubeSide upperLeftPiece.
	upperRightPieceMorph := self openMorphAtOrigin: aPoint gameMorph: gameMorph pieceOffset: 42@0 color: self pocketCubeSide upperRightPiece.
	lowerRightPieceMorph := self openMorphAtOrigin: aPoint gameMorph: gameMorph pieceOffset: 42@42 color: self pocketCubeSide lowerRightPiece.
	lowerLeftPieceMorph := self openMorphAtOrigin: aPoint gameMorph: gameMorph pieceOffset: 0@42 color: self pocketCubeSide lowerLeftPiece.! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 12:53'!
openMorphAtOrigin: aPoint gameMorph: gameMorph pieceOffset: offset color: aColor
	
	| pieceMorph |
	pieceMorph := self openBorderedRectangleMorph.
	gameMorph addMorph: pieceMorph.
	pieceMorph position: gameMorph position + offset + aPoint.
	pieceMorph color: aColor.
	^pieceMorph! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 02:11'!
pocketCube: aPocketCube 

	pocketCube := aPocketCube! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 02:08'!
pocketCubeSide

	^pocketCube perform: sideAccessor! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 19:25'!
refreshMorph

	upperLeftPieceMorph color: self pocketCubeSide upperLeftPiece.
	upperRightPieceMorph color: self pocketCubeSide upperRightPiece.
	lowerLeftPieceMorph color: self pocketCubeSide lowerLeftPiece.
	lowerRightPieceMorph color: self pocketCubeSide lowerRightPiece.! !

!PocketCubeSideController methodsFor: 'as yet unclassified' stamp: 'hjo 7/26/2010 02:11'!
sideAccessor: aByteSymbol 

	sideAccessor := aByteSymbol! !

PocketCubeSideController subclass: #PocketCubeVirtualSideController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Morph'!

!PocketCubeVirtualSideController methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 19:28'!
alpha

	^0.3! !

!PocketCubeVirtualSideController methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 19:34'!
noBoarder

	upperLeftPieceMorph borderWidth: 0.
	upperRightPieceMorph borderWidth: 0.
	lowerLeftPieceMorph borderWidth: 0.
	lowerRightPieceMorph borderWidth: 0.! !

!PocketCubeVirtualSideController methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 19:28'!
refreshAlpha.

	upperLeftPieceMorph color: (upperLeftPieceMorph color alpha: self alpha).
	lowerLeftPieceMorph color: (lowerLeftPieceMorph color alpha: self alpha).
	upperRightPieceMorph color: (upperRightPieceMorph color alpha: self alpha).
	lowerRightPieceMorph color: (lowerRightPieceMorph color alpha: self alpha).! !

!PocketCubeVirtualSideController methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 19:33'!
refreshMorph

	super refreshMorph.
	self refreshAlpha.
	self noBoarder.! !

Object subclass: #SidePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

SidePattern subclass: #BarSidePattern
	instanceVariableNames: 'barColor colorOfLeftToTheBar colorOfRightToTheBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!BarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:11'!
confirmedFor: aPocketCubeSide

	| instance |
	instance := self new.
	instance barColor: (aPocketCubeSide perform: self barColorGetter).
	instance colorOfLeftToTheBar: (aPocketCubeSide perform: self colorOfLeftToTheBarGetter).
	instance colorOfRightToTheBar: (aPocketCubeSide perform: self colorOfRightToTheBarGetter).
	^instance! !

!BarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:23'!
numberOfColor

	^3! !

!BarSidePattern methodsFor: 'accessing' stamp: 'hjo 2/3/2011 21:31'!
barColor
	^ barColor! !

!BarSidePattern methodsFor: 'accessing' stamp: 'hjo 2/3/2011 21:31'!
barColor: anObject
	barColor := anObject! !

!BarSidePattern methodsFor: 'accessing' stamp: 'hjo 2/3/2011 21:32'!
colorOfLeftToTheBar
	^ colorOfLeftToTheBar! !

!BarSidePattern methodsFor: 'accessing' stamp: 'hjo 2/3/2011 21:32'!
colorOfLeftToTheBar: anObject
	colorOfLeftToTheBar := anObject! !

!BarSidePattern methodsFor: 'accessing' stamp: 'hjo 2/3/2011 21:32'!
colorOfRightToTheBar
	^ colorOfRightToTheBar! !

!BarSidePattern methodsFor: 'accessing' stamp: 'hjo 2/3/2011 21:32'!
colorOfRightToTheBar: anObject
	colorOfRightToTheBar := anObject! !

BarSidePattern subclass: #BottomBarSidePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!BottomBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:13'!
barColorGetter

	^#lowerLeftPiece! !

!BottomBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 22:48'!
checkBarPieceMatch: aPocketCubeSide

	^aPocketCubeSide lowerLeftPiece = aPocketCubeSide lowerRightPiece! !

!BottomBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:14'!
colorOfLeftToTheBarGetter

	^#upperLeftPiece! !

!BottomBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:14'!
colorOfRightToTheBarGetter

	^#upperRightPiece! !

BarSidePattern subclass: #LeftBarSidePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!LeftBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:15'!
barColorGetter

	^#upperLeftPiece! !

!LeftBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 22:49'!
checkBarPieceMatch: aPocketCubeSide

	^aPocketCubeSide lowerLeftPiece = aPocketCubeSide upperLeftPiece! !

!LeftBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:15'!
colorOfLeftToTheBarGetter

	^#upperRightPiece! !

!LeftBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:22'!
colorOfRightToTheBarGetter

	^#lowerRightPiece! !

!LeftBarSidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 19:39'!
isLeftBar

	^true! !

BarSidePattern subclass: #RightBarSidePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!RightBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:22'!
barColorGetter

	^#upperRightPiece! !

!RightBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 22:50'!
checkBarPieceMatch: aPocketCubeSide

	^aPocketCubeSide lowerRightPiece = aPocketCubeSide upperRightPiece! !

!RightBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:23'!
colorOfLeftToTheBarGetter

	^#lowerLeftPiece! !

!RightBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:23'!
colorOfRightToTheBarGetter

	^#upperLeftPiece! !

!RightBarSidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 19:39'!
isRightBar

	^true! !

BarSidePattern subclass: #TopBarSidePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!TopBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:24'!
barColorGetter

	^#upperRightPiece! !

!TopBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 22:50'!
checkBarPieceMatch: aPocketCubeSide

	^aPocketCubeSide upperLeftPiece = aPocketCubeSide upperRightPiece! !

!TopBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:24'!
colorOfLeftToTheBarGetter

	^#lowerRightPiece! !

!TopBarSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 23:24'!
colorOfRightToTheBarGetter

	^#lowerLeftPiece! !

SidePattern subclass: #FourColorSidePattern
	instanceVariableNames: 'side'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!FourColorSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 13:33'!
checkBarPieceMatch: aPocketCubeSide 

	^true! !

!FourColorSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 13:34'!
confirmedFor: aPocketCubeSide 

	| instance |
	instance := self new.
	instance side: aPocketCubeSide copy.
	^instance.! !

!FourColorSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 13:32'!
numberOfColor

	^4! !

!FourColorSidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 13:35'!
side

	^side! !

!FourColorSidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 13:34'!
side: aPocketCubeSide 

	side := aPocketCubeSide! !

SidePattern subclass: #LSidePattern
	instanceVariableNames: 'colorOfL colorOfDot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

LSidePattern subclass: #BottomLeftLSidePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!BottomLeftLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 00:39'!
checkBarPieceMatch: aPocketCubeSide 

	^(Set with: aPocketCubeSide upperLeftPiece with: aPocketCubeSide lowerLeftPiece with: aPocketCubeSide lowerRightPiece) size = 1! !

!BottomLeftLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:42'!
colorOfDotGetter

	^#upperRightPiece! !

!BottomLeftLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:42'!
colorOfLGetter

	^#lowerLeftPiece.! !

LSidePattern subclass: #BottomRightLSidePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!BottomRightLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 00:31'!
checkBarPieceMatch: aPocketCubeSide 

	^(Set with: aPocketCubeSide upperRightPiece with: aPocketCubeSide lowerLeftPiece with: aPocketCubeSide lowerRightPiece) size = 1! !

!BottomRightLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:44'!
colorOfDotGetter

	^#upperLeftPiece.! !

!BottomRightLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:43'!
colorOfLGetter

	^#lowerRightPiece.! !

!LSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:41'!
confirmedFor: aPocketCubeSide 

	| instance |
	instance := self new.
	instance colorOfL: (aPocketCubeSide perform: self colorOfLGetter).
	instance colorOfDot: (aPocketCubeSide perform: self colorOfDotGetter).
	^instance! !

!LSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:27'!
numberOfColor

	^2! !

!LSidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 00:33'!
colorOfDot

	^colorOfDot! !

!LSidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 00:33'!
colorOfDot: aColor 

	colorOfDot := aColor ! !

!LSidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 00:33'!
colorOfL

	^colorOfL! !

!LSidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 00:34'!
colorOfL: aColor 

	colorOfL := aColor! !

LSidePattern subclass: #TopLeftLSidePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!TopLeftLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:19'!
checkBarPieceMatch: aPocketCubeSide 

	^(Set with: aPocketCubeSide upperLeftPiece with: aPocketCubeSide upperRightPiece with: aPocketCubeSide lowerLeftPiece) size = 1! !

!TopLeftLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:45'!
colorOfDotGetter

	^#lowerRightPiece.! !

!TopLeftLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:44'!
colorOfLGetter

	^#upperLeftPiece.! !

LSidePattern subclass: #TopRightLSidePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!TopRightLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:15'!
checkBarPieceMatch: aPocketCubeSide 

	^(Set with: aPocketCubeSide upperLeftPiece
	with: aPocketCubeSide upperRightPiece
	with: aPocketCubeSide lowerRightPiece) size = 1! !

!TopRightLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:45'!
colorOfDotGetter

	^#lowerLeftPiece.! !

!TopRightLSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:45'!
colorOfLGetter

	^#upperRightPiece.! !

SidePattern subclass: #ParallelSidePattern
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

ParallelSidePattern subclass: #HorizontallyParallelSidePattern
	instanceVariableNames: 'colorOfTopBar colorOfBottomBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!HorizontallyParallelSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 13:19'!
checkBarPieceMatch: aPocketCubeSide

	^(aPocketCubeSide lowerLeftPiece = aPocketCubeSide lowerRightPiece)
		and: [aPocketCubeSide upperLeftPiece = aPocketCubeSide upperRightPiece]! !

!HorizontallyParallelSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 13:35'!
confirmedFor: aPocketCubeSide

	| instance |
	instance := self new.
	instance colorOfTopBar: aPocketCubeSide upperLeftPiece.
	instance colorOfBottomBar: aPocketCubeSide lowerLeftPiece.
	^instance! !

!HorizontallyParallelSidePattern methodsFor: 'accessing' stamp: 'hjo 2/4/2011 13:37'!
colorOfBottomBar
	^ colorOfBottomBar! !

!HorizontallyParallelSidePattern methodsFor: 'accessing' stamp: 'hjo 2/4/2011 13:37'!
colorOfBottomBar: anObject
	colorOfBottomBar := anObject! !

!HorizontallyParallelSidePattern methodsFor: 'accessing' stamp: 'hjo 2/4/2011 13:13'!
colorOfTopBar
	^ colorOfTopBar! !

!HorizontallyParallelSidePattern methodsFor: 'accessing' stamp: 'hjo 2/4/2011 13:13'!
colorOfTopBar: anObject
	colorOfTopBar := anObject! !

!ParallelSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:26'!
numberOfColor

	^2! !

!ParallelSidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 13:49'!
isParallelPattern

	^true! !

ParallelSidePattern subclass: #VerticallyParallelSidePattern
	instanceVariableNames: 'colorOfLeftBar colorOfRightBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!VerticallyParallelSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 13:52'!
checkBarPieceMatch: aPocketCubeSide

	^(aPocketCubeSide lowerLeftPiece = aPocketCubeSide upperLeftPiece)
		and: [aPocketCubeSide lowerRightPiece = aPocketCubeSide upperRightPiece]! !

!VerticallyParallelSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 13:53'!
confirmedFor: aPocketCubeSide

	| instance |
	instance := self new.
	instance colorOfLeftBar: aPocketCubeSide upperLeftPiece.
	instance colorOfRightBar: aPocketCubeSide upperRightPiece.
	^instance! !

!VerticallyParallelSidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 13:44'!
colorOfLeftBar

	^colorOfLeftBar! !

!VerticallyParallelSidePattern methodsFor: 'accessing' stamp: 'hjo 2/3/2011 21:52'!
colorOfLeftBar: aColor 

	colorOfLeftBar := aColor ! !

!VerticallyParallelSidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 13:44'!
colorOfRightBar

	^colorOfRightBar! !

!VerticallyParallelSidePattern methodsFor: 'accessing' stamp: 'hjo 2/3/2011 21:52'!
colorOfRightBar: aColor 

	colorOfRightBar := aColor ! !

!SidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 00:50'!
checkMatch: aPocketCubeSide 

	^(self checkPieceSetSizeMatch: aPocketCubeSide) and: [self checkBarPieceMatch: aPocketCubeSide]! !

!SidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:24'!
checkPieceSetSizeMatch: aPocketCubeSide 

	^aPocketCubeSide pieceSet size = self numberOfColor! !

!SidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:34'!
for: aPocketCubeSide 

	(self checkMatch: aPocketCubeSide) ifFalse: [^nil].
	^self confirmedFor: aPocketCubeSide.! !

!SidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 19:39'!
isLeftBar

	^false! !

!SidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 21:33'!
isParallelPattern

	^false! !

!SidePattern methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 19:39'!
isRightBar

	^false! !

SidePattern subclass: #UnifiedSidePattern
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns'!

!UnifiedSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 00:51'!
checkBarPieceMatch: aPocketCubeSide 

	^true! !

!UnifiedSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 00:53'!
confirmedFor: aPocketCubeSide 

	|instance|
	instance := self new.
	instance color: aPocketCubeSide upperLeftPiece.
	^instance ! !

!UnifiedSidePattern classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:26'!
numberOfColor

	^1! !

!UnifiedSidePattern methodsFor: 'accessing' stamp: 'hjo 2/3/2011 21:16'!
color
	^ color! !

!UnifiedSidePattern methodsFor: 'accessing' stamp: 'hjo 2/3/2011 21:16'!
color: aColor
	color := aColor! !

RectangleMorph subclass: #PocketCubeGameMorph
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Morph'!

!PocketCubeGameMorph methodsFor: 'as yet unclassified' stamp: 'hjo 7/31/2010 19:42'!
controller

	^controller! !

!PocketCubeGameMorph methodsFor: 'as yet unclassified' stamp: 'hjo 7/31/2010 19:42'!
controller: aPocketCubeController 

	controller := aPocketCubeController 
! !

!PocketCubeGameMorph methodsFor: 'as yet unclassified' stamp: 'hjo 7/31/2010 19:23'!
handlesKeyboard: evt

	^true! !

!PocketCubeGameMorph methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 20:46'!
initialize 

	super initialize.
	self openInWorld.
	self bounds: (0@0 corner: 640@480).
	self extent:  454@454.
	self position: 0@0.
	self color: Color white.
! !

!PocketCubeGameMorph methodsFor: 'as yet unclassified' stamp: 'hjo 7/31/2010 19:49'!
keyStroke: anEvent

	anEvent keyValue = 97 ifTrue: [^self controller rotateLeft].
	anEvent keyValue = 115 ifTrue: [^self controller rotateRight].
	anEvent keyValue = 122 ifTrue: [^self controller rotateClockwise].
	anEvent keyValue = 120 ifTrue: [^self controller rotateCounterClockwise].	
	anEvent keyValue = 106 ifTrue: [^self controller twistUpperLayerLeft].	
	anEvent keyValue = 107 ifTrue: [^self controller twistUpperLayerRight].
	anEvent keyValue = 110 ifTrue: [^self controller twistLowerLayerLeft].
	anEvent keyValue = 109 ifTrue: [^self controller twistLowerLayerRight].
	Transcript show: anEvent keyValue; cr! !

TestCase subclass: #PocketCubeColorPieceTest
	instanceVariableNames: 'pocketCube hasReceivedHasPocketCubeChanged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeColorPieceTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 21:08'!
onPocketCubeChanged

	hasReceivedHasPocketCubeChanged := true.! !

!PocketCubeColorPieceTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 21:08'!
setUp

	super setUp.
	hasReceivedHasPocketCubeChanged := false.
	pocketCube := PocketCube new.
	pocketCube initializeSidesWithColors.
	pocketCube when: #pocketCubeChanged send: #onPocketCubeChanged  to: self! !

!PocketCubeColorPieceTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 19:11'!
testSidesAreUpperLayerTwistedLeft

	self deny: pocketCube sidesAreUpperLayerTwistedLeft.
	pocketCube twistUpperLayerLeft.
	self assert: pocketCube sidesAreUpperLayerTwistedLeft.! !

!PocketCubeColorPieceTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 19:11'!
testSidesAreUpperLayerTwistedRight

	self deny: pocketCube sidesAreUpperLayerTwistedRight.
	pocketCube twistUpperLayerRight.
	self assert: pocketCube sidesAreUpperLayerTwistedRight.! !

!PocketCubeColorPieceTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 19:13'!
testSidesAreUpperLayerTwistedTwice

	self deny: pocketCube sidesAreUpperLayerTwistedTwice.
	2 timesRepeat: [pocketCube twistUpperLayerRight].
	self assert: pocketCube sidesAreUpperLayerTwistedTwice.! !

!PocketCubeColorPieceTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 21:10'!
testTwistLowerLayerLeft

	pocketCube twistLowerLayerLeft.
	self assert: hasReceivedHasPocketCubeChanged ! !

!PocketCubeColorPieceTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 21:09'!
testTwistLowerLayerRight

	pocketCube twistLowerLayerRight.
	self assert: hasReceivedHasPocketCubeChanged ! !

!PocketCubeColorPieceTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 21:11'!
testTwistUpperLayerLeft

	pocketCube twistUpperLayerLeft.
	self assert: hasReceivedHasPocketCubeChanged ! !

!PocketCubeColorPieceTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/2/2011 21:11'!
testTwistUpperLayerRight

	pocketCube twistUpperLayerRight.
	self assert: hasReceivedHasPocketCubeChanged ! !

TestCase subclass: #PocketCubeNumberPieceTest
	instanceVariableNames: 'pocketCube'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeNumberPieceTest methodsFor: 'running' stamp: 'hjo 7/17/2010 20:32'!
setUp

	super setUp.
	pocketCube := PocketCube new.
	pocketCube topSide: (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4).
	pocketCube leftSide: (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6 lowerLeftPiece: 13 lowerRightPiece: 14).
	pocketCube bottomSide: (PocketCubeSide upperLeftPiece: 21 upperRightPiece: 22 lowerLeftPiece: 23 lowerRightPiece: 24).
	pocketCube rightSide: (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 17 lowerRightPiece: 18).
	pocketCube frontSide: (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 15 lowerRightPiece: 16).
	pocketCube backSide: (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 19 lowerRightPiece: 20).! !

!PocketCubeNumberPieceTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:36'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece:11 upperRightPiece: 12 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeNumberPieceTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:36'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 21 upperRightPiece: 22 lowerLeftPiece: 23 lowerRightPiece: 24)! !

!PocketCubeNumberPieceTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:36'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeNumberPieceTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:37'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6 lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeNumberPieceTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:37'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeNumberPieceTest methodsFor: 'setup testing' stamp: 'hjo 2/7/2011 10:21'!
testSideColumn

	|sides|
	sides := pocketCube sideColumn.
	self assert: (PocketCubeSide upperLeftPiece: 2 upperRightPiece: 4 lowerLeftPiece: 1 lowerRightPiece: 3) equals: (sides at: 1).
	self assert: (PocketCubeSide upperLeftPiece: 8 upperRightPiece: 16 lowerLeftPiece: 7 lowerRightPiece: 15) equals: (sides at: 2).
	self assert: (PocketCubeSide upperLeftPiece: 22 upperRightPiece: 24 lowerLeftPiece: 21 lowerRightPiece: 23) equals: (sides at: 3).
	self assert: (PocketCubeSide upperLeftPiece: 19 upperRightPiece: 11 lowerLeftPiece: 20 lowerRightPiece: 12) equals: (sides at: 4).! !

!PocketCubeNumberPieceTest methodsFor: 'setup testing' stamp: 'hjo 2/6/2011 19:25'!
testSideRow

	|sides|
	sides := pocketCube sideRow.
	self assert: (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6 lowerLeftPiece: 13 lowerRightPiece: 14) equals: (sides at: 1).
	self assert: (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 15 lowerRightPiece: 16) equals: (sides at: 2).
	self assert: (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 17 lowerRightPiece: 18) equals: (sides at: 3).
	self assert: (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 19 lowerRightPiece: 20) equals: (sides at: 4).! !

!PocketCubeNumberPieceTest methodsFor: 'setup testing' stamp: 'hjo 7/18/2010 07:37'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4)! !

PocketCubeNumberPieceTest subclass: #PocketCubeRotateClockwiseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:52'!
setUp

	super setUp.
	pocketCube rotateClockwise.! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:53'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece:12 upperRightPiece: 20 lowerLeftPiece: 11 lowerRightPiece: 19)! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:55'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 17 upperRightPiece: 9 lowerLeftPiece: 18 lowerRightPiece: 10)! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:54'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece:15 upperRightPiece: 7 lowerLeftPiece: 16 lowerRightPiece: 8)! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:55'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 23 upperRightPiece: 21 lowerLeftPiece: 24 lowerRightPiece: 22)! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:56'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 3 upperRightPiece: 1 lowerLeftPiece: 4 lowerRightPiece: 2)! !

!PocketCubeRotateClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:56'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 13 upperRightPiece: 5 lowerLeftPiece: 14 lowerRightPiece: 6)! !

PocketCubeNumberPieceTest subclass: #PocketCubeRotateCounterClockwiseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:13'!
setUp

	super setUp.
	pocketCube rotateCounterClockwise.! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:15'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece:19 upperRightPiece: 11 lowerLeftPiece: 20 lowerRightPiece: 12)! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:16'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 6 upperRightPiece: 14 lowerLeftPiece: 5 lowerRightPiece: 13)! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:16'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece:8 upperRightPiece: 16 lowerLeftPiece: 7 lowerRightPiece: 15)! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:17'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 2 upperRightPiece: 4 lowerLeftPiece: 1 lowerRightPiece: 3)! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:17'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 22 upperRightPiece: 24 lowerLeftPiece: 21 lowerRightPiece: 23)! !

!PocketCubeRotateCounterClockwiseTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 22:18'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 10 upperRightPiece: 18 lowerLeftPiece: 9 lowerRightPiece: 17)! !

PocketCubeNumberPieceTest subclass: #PocketCubeRotateLeftTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 01:35'!
setUp

	super setUp.
	pocketCube rotateLeft.! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:43'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece:9 upperRightPiece: 10 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:23'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 23 upperRightPiece: 21 lowerLeftPiece: 24 lowerRightPiece: 22)! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:38'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece:5 upperRightPiece: 6 lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:30'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:33'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeRotateLeftTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:40'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 2 upperRightPiece: 4 lowerLeftPiece: 1 lowerRightPiece: 3)! !

PocketCubeNumberPieceTest subclass: #PocketCubeRotateRightTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:29'!
setUp

	super setUp.
	pocketCube rotateRight.! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:34'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece:5 upperRightPiece: 6 lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:34'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 22 upperRightPiece: 24 lowerLeftPiece: 21 lowerRightPiece: 23)! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:37'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece:9 upperRightPiece: 10 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:39'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:39'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeRotateRightTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 09:37'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 3 upperRightPiece: 1 lowerLeftPiece: 4 lowerRightPiece: 2)! !

PocketCubeNumberPieceTest subclass: #PocketCubeWhenTwistLowerLayerLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:15'!
setUp

	super setUp.
	pocketCube twistLowerLayerLeft.! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:19'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 13 lowerRightPiece: 14).! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:20'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 22 upperRightPiece: 24 lowerLeftPiece: 21 lowerRightPiece: 23)! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:18'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 17 lowerRightPiece: 18).! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:18'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6  lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:19'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeWhenTwistLowerLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:20'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2  lowerLeftPiece: 3 lowerRightPiece: 4)! !

PocketCubeNumberPieceTest subclass: #PocketCubeWhenTwistLowerLayerRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:22'!
setUp

	super setUp.
	pocketCube twistLowerLayerRight! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:25'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:23'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 23 upperRightPiece: 21 lowerLeftPiece: 24 lowerRightPiece: 22).! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:24'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:23'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6  lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:24'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeWhenTwistLowerLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:22'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2  lowerLeftPiece: 3 lowerRightPiece: 4)! !

PocketCubeNumberPieceTest subclass: #PocketCubeWhenTwistUpperLayerLeft
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:27'!
setUp

	super setUp.
	pocketCube twistUpperLayerLeft! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:28'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:28'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 21 upperRightPiece: 22 lowerLeftPiece: 23 lowerRightPiece: 24).! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:27'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:27'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8  lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:28'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeWhenTwistUpperLayerLeft methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:29'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 3 upperRightPiece: 1 lowerLeftPiece: 4 lowerRightPiece: 2)! !

PocketCubeNumberPieceTest subclass: #PocketCubeWhenTwistUpperLayerRight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:30'!
setUp

	super setUp.
	pocketCube twistUpperLayerRight! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:31'!
testBackSide

	self assert: pocketCube backSide = (PocketCubeSide upperLeftPiece: 9 upperRightPiece: 10 lowerLeftPiece: 19 lowerRightPiece: 20)! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:30'!
testBottomSide

	self assert: pocketCube bottomSide = (PocketCubeSide upperLeftPiece: 21 upperRightPiece: 22 lowerLeftPiece: 23 lowerRightPiece: 24).! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:31'!
testFrontSide

	self assert: pocketCube frontSide = (PocketCubeSide upperLeftPiece: 5 upperRightPiece: 6 lowerLeftPiece: 15 lowerRightPiece: 16)! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:31'!
testLeftSide

	self assert: pocketCube leftSide = (PocketCubeSide upperLeftPiece: 11 upperRightPiece: 12  lowerLeftPiece: 13 lowerRightPiece: 14)! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:31'!
testRightSide

	self assert: pocketCube rightSide = (PocketCubeSide upperLeftPiece: 7 upperRightPiece: 8 lowerLeftPiece: 17 lowerRightPiece: 18)! !

!PocketCubeWhenTwistUpperLayerRight methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:32'!
testTopSide

	self assert: pocketCube topSide = (PocketCubeSide upperLeftPiece: 2 upperRightPiece: 4 lowerLeftPiece: 1 lowerRightPiece: 3)! !

TestCase subclass: #PocketCubeScrambleOperationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeScrambleOperationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:24'!
testX1

	self assert: #(#twistLowerLayerLeft) equals: (ScrambleX new amount: 1) operations
	! !

!PocketCubeScrambleOperationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:24'!
testX2

	self assert: #(#twistLowerLayerLeft #twistLowerLayerLeft) equals: (ScrambleX new amount: 2) operations! !

!PocketCubeScrambleOperationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:24'!
testY1

	self assert: #(#rotateCounterClockwise #twistUpperLayerRight #rotateClockwise) equals: (ScrambleY new amount: 1) operations
	! !

!PocketCubeScrambleOperationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:25'!
testY2

	self assert: #(#rotateCounterClockwise #twistUpperLayerRight #twistUpperLayerRight  #rotateClockwise) equals:  (ScrambleY new amount: 2) operations
	! !

!PocketCubeScrambleOperationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:25'!
testYNeg1

	self assert: #(#rotateCounterClockwise #twistUpperLayerLeft #rotateClockwise) equals: (ScrambleY new amount: -1) operations! !

!PocketCubeScrambleOperationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:25'!
testZ1

	self assert: #(#rotateRight #rotateCounterClockwise #twistLowerLayerLeft #rotateClockwise #rotateLeft) equals: (ScrambleZ new amount: 1) operations
	! !

!PocketCubeScrambleOperationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:26'!
testZ2

	self assert: #(#rotateRight #rotateCounterClockwise #twistLowerLayerLeft #twistLowerLayerLeft #rotateClockwise #rotateLeft) equals: (ScrambleZ new amount: 2) operations
	! !

!PocketCubeScrambleOperationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 13:26'!
testZNeg1

	self assert: #(#rotateRight #rotateCounterClockwise #twistLowerLayerRight #rotateClockwise #rotateLeft) equals: (ScrambleZ new amount: -1) operations! !

TestCase subclass: #PocketCubeSideTest
	instanceVariableNames: 'side'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:45'!
setUp

	super setUp.
	side := PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 20:03'!
testCopyInLowerLayer

	side copyInLowerLayer: (Array with: 5 with: 6).
	self assert: side copyOutUpperLayer = (Array with:1 with:2).
	self assert: side copyOutLowerLayer = (Array with:5 with:6)! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 20:01'!
testCopyInUpperLayer

	side copyInUpperLayer: (Array with: 5 with: 6).
	self assert: side copyOutUpperLayer = (Array with:5 with:6).
	self assert: side copyOutLowerLayer = (Array with:3 with:4)! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:54'!
testCopyOutLowerLayer

	|twoPieces| 
	twoPieces := side copyOutLowerLayer.
	self assert: twoPieces = (Array with:3 with:4)! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:53'!
testCopyOutUpperLayer

	|twoPieces| 
	twoPieces := side copyOutUpperLayer.
	self assert: twoPieces = (Array with:1 with:2)! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 01:31'!
testEqual

	self assert: side = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4).
	self deny: side = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 6 lowerLeftPiece: 3 lowerRightPiece: 4).
	self deny: side = (PocketCubeSide upperLeftPiece: 0 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4).
	self deny: side = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 9 lowerRightPiece: 4).
	self deny: side = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 7).
! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 01:32'!
testHash

	self assert: side hash = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4) hash.
	self deny: side hash = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 6 lowerLeftPiece: 3 lowerRightPiece: 4) hash.
	self deny: side hash = (PocketCubeSide upperLeftPiece: 0 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 4) hash.
	self deny: side hash = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 9 lowerRightPiece: 4) hash.
	self deny: side hash = (PocketCubeSide upperLeftPiece: 1 upperRightPiece: 2 lowerLeftPiece: 3 lowerRightPiece: 7) hash.
! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/18/2010 07:54'!
testPrintPieces

	self assert: side printPieces = 
'1 2
3 4'! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:35'!
testRotateClockwise

	side rotateClockwise.
	self assert: side upperLeftPiece = 3.
	self assert: side upperRightPiece = 1.
	self assert: side lowerLeftPiece = 4.
	self assert: side lowerRightPiece = 2! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:46'!
testRotateCounterClockwise

	side rotateCounterClockwise.
	self assert: side upperLeftPiece = 2.
	self assert: side upperRightPiece = 4.
	self assert: side lowerLeftPiece = 1.
	self assert: side lowerRightPiece = 3! !

!PocketCubeSideTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/17/2010 19:37'!
testSetup

	self assert: side upperLeftPiece = 1.
	self assert: side upperRightPiece = 2.
	self assert: side lowerLeftPiece = 3.
	self assert: side lowerRightPiece = 4! !

TestCase subclass: #PocketCubeSolverTest
	instanceVariableNames: 'pocketcube solver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-Tests'!

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 13:21'!
setUp

	super setUp.
	pocketcube := PocketCube new.
	pocketcube initializeSidesWithColors.
	solver := PocketCubeRecognizer on: pocketcube.! !

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 21:43'!
testComplicatedCase2

	pocketcube rotateRight; rotateCounterClockwise; twistLowerLayerRight; rotateCounterClockwise; twistLowerLayerRight; twistLowerLayerRight; rotateCounterClockwise; twistUpperLayerLeft.

	self assert: PocketCubeComplicatedPattern2 equals: solver scanPattern.
	solver oneStepBetter.
	self assert: PocketCubePatternFor1UnifiedSideAnd3VertiallyParallelSides equals: solver scanPattern.! !

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 14:07'!
testComplicatedUpperLayerTwistedRight

	pocketcube rotateClockwise.
	pocketcube twistLowerLayerRight.
	pocketcube twistLowerLayerRight.
	pocketcube rotateClockwise.
	pocketcube twistLowerLayerRight.
	pocketcube rotateCounterClockwise.
	pocketcube twistLowerLayerLeft.

	self assert: PocketCubeComplicatedUpperLayerTwistedPattern equals: solver scanPattern.
	solver oneStepBetter.
	self assert: PocketCubeVerticallyLayerTwistedPattern equals: solver scanPattern.! !

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 13:27'!
testFrontSideBackSideOneColor

	pocketcube twistUpperLayerLeft.
	pocketcube rotateClockwise.
	pocketcube rotateLeft.
	self assert: PocketCubeFrontSideBackSideOneColorPattern equals: solver scanPattern.
	solver oneStepBetter.
	self assert: PocketCubeVerticallyLayerTwistedPattern equals: solver scanPattern.! !

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 19:17'!
testOrder3Case1

	pocketcube 
 		rotateRight;
		rotateCounterClockwise;
		twistLowerLayerRight;
		rotateClockwise;
		rotateLeft;
		rotateCounterClockwise;
		twistUpperLayerLeft;
		rotateClockwise;
		rotateRight;
		rotateCounterClockwise;
		twistLowerLayerLeft;
		twistLowerLayerLeft;
		rotateClockwise;
		rotateLeft.
	self assert: PocketCubeOrder3Case1Pattern equals: solver scanPattern.
	solver oneStepBetter.! !

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/7/2011 19:41'!
testOrder3Case2

	| pattern |
	pocketcube 
 		rotateRight;
		rotateCounterClockwise;
		twistLowerLayerRight;
		rotateClockwise;
		rotateLeft;
		rotateCounterClockwise;
		twistUpperLayerLeft;
		rotateClockwise;
		rotateRight;
		rotateCounterClockwise;
		twistLowerLayerLeft;
		twistLowerLayerLeft;
		rotateClockwise.
	pattern := solver scanPattern.
	self assert: PocketCubeOrder3Case2Pattern equals: pattern.
	self assert: #rotateCounterClockwise equals: pattern selectorForOneStepBetter.! !

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 13:23'!
testSolved

	self assert: PocketCubeSolvedPattern equals: solver scanPattern.
	solver oneStepBetter.
	! !

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 13:29'!
testUnknownPattern

	self should: [PocketCubeUnknownPattern oneStepBetterFor: pocketcube] raise: Error! !

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 13:31'!
testUpperLayerTwistedLeftPattern

	pocketcube twistUpperLayerLeft.
	self assert: PocketCubeUpperLayerTwistedLeftPattern equals: solver scanPattern.
	solver oneStepBetter.
	self assert: PocketCubeSolvedPattern equals: solver scanPattern.! !

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 13:31'!
testUpperLayerTwistedRightPattern

	pocketcube twistUpperLayerRight.
	self assert: PocketCubeUpperLayerTwistedRightPattern equals: solver scanPattern.
	solver oneStepBetter.
	self assert: PocketCubeSolvedPattern equals: solver scanPattern.! !

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 13:32'!
testUpperLayerTwistedTwicePattern

	2 timesRepeat: [pocketcube twistUpperLayerRight].
	self assert: PocketCubeUpperLayerTwistedTwicePattern equals: solver scanPattern.
	solver oneStepBetter.
	self assert: PocketCubeSolvedPattern equals: solver scanPattern.! !

!PocketCubeSolverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 13:34'!
testVerticallyLayerTwistedPattern

	pocketcube twistUpperLayerRight.
	pocketcube rotateClockwise.
	self assert: PocketCubeVerticallyLayerTwistedPattern equals: solver scanPattern.
	solver oneStepBetter.
	self assert: PocketCubeUpperLayerTwistedRightPattern equals: solver scanPattern.! !

TestCase subclass: #SidePatternTest
	instanceVariableNames: 'pocketCubeSide'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PocketCube-SidePatterns-Tests'!

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 21:22'!
setUp

	super setUp.! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 21:25'!
testBottomBarSidePattern

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color yellow  upperRightPiece: Color blue lowerLeftPiece: Color green lowerRightPiece: Color green.
	pattern := pocketCubeSide sidePattern.
	self assert: BottomBarSidePattern equals: pattern class.
	self assert: Color green equals: pattern barColor.
	self assert: Color yellow equals: pattern colorOfLeftToTheBar.
	self assert: Color blue equals: pattern colorOfRightToTheBar.! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 14:30'!
testBottomLeftL

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color blue upperRightPiece: Color red lowerLeftPiece: Color blue lowerRightPiece: Color blue.
	pattern := pocketCubeSide sidePattern.
	self assert: BottomLeftLSidePattern equals: pattern class.
	self assert: Color blue equals: pattern colorOfL.
	self assert: Color red equals: pattern colorOfDot.

! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 20:49'!
testBottomRightL

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color red upperRightPiece: Color blue lowerLeftPiece: Color blue lowerRightPiece: Color blue.
	pattern := pocketCubeSide sidePattern.
	self assert: BottomRightLSidePattern equals: pattern class.
	self assert: Color blue equals: pattern colorOfL.
	self assert: Color red equals: pattern colorOfDot.

! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 13:35'!
testFourColor

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color yellow  upperRightPiece: Color blue lowerLeftPiece: Color green lowerRightPiece: Color red.
	pattern := pocketCubeSide sidePattern.
	self assert: FourColorSidePattern equals: pattern class.
	self assert: pocketCubeSide equals: pattern side.! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 13:34'!
testHorizontallyParallel

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color white upperRightPiece: Color white lowerLeftPiece: Color green lowerRightPiece: Color green.
	pattern := pocketCubeSide sidePattern.
	self assert: HorizontallyParallelSidePattern equals: pattern class.
	self assert: Color white equals: pattern colorOfTopBar.
	self assert: Color green equals: pattern colorOfBottomBar.

! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 21:59'!
testLeftBarSidePattern

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color yellow  upperRightPiece: Color blue lowerLeftPiece: Color yellow lowerRightPiece: Color green.
	pattern := pocketCubeSide sidePattern.
	self assert: LeftBarSidePattern equals: pattern class.
	self assert: Color yellow equals: pattern barColor.
	self assert: Color blue equals: pattern colorOfLeftToTheBar.
	self assert: Color green equals: pattern colorOfRightToTheBar.! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 22:27'!
testRightBarSidePattern

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color blue upperRightPiece: Color yellow lowerLeftPiece: Color green lowerRightPiece: Color yellow.
	pattern := pocketCubeSide sidePattern.
	self assert: RightBarSidePattern equals: pattern class.
	self assert: Color yellow equals: pattern barColor.
	self assert: Color green equals: pattern colorOfLeftToTheBar.
	self assert: Color blue equals: pattern colorOfRightToTheBar.! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/3/2011 22:35'!
testTopBarSidePattern

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color orange upperRightPiece: Color orange lowerLeftPiece: Color green lowerRightPiece: Color yellow.
	pattern := pocketCubeSide sidePattern.
	self assert: TopBarSidePattern equals: pattern class.
	self assert: Color orange equals: pattern barColor.
	self assert: Color yellow equals: pattern colorOfLeftToTheBar.
	self assert: Color green equals: pattern colorOfRightToTheBar.! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:17'!
testTopLeftL

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color green upperRightPiece: Color green lowerLeftPiece: Color green lowerRightPiece: Color red.
	pattern := pocketCubeSide sidePattern.
	self assert: TopLeftLSidePattern equals: pattern class.
	self assert: Color green equals: pattern colorOfL.
	self assert: Color red equals: pattern colorOfDot.

! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2011 12:13'!
testTopRightL

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color green upperRightPiece: Color green lowerLeftPiece: Color red lowerRightPiece: Color green.
	pattern := pocketCubeSide sidePattern.
	self assert: TopRightLSidePattern equals: pattern class.
	self assert: Color green equals: pattern colorOfL.
	self assert: Color red equals: pattern colorOfDot.

! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 13:39'!
testUnifiedSidePattern

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color green  upperRightPiece: Color green lowerLeftPiece: Color green lowerRightPiece: Color green.
	pattern := pocketCubeSide sidePattern.
	self assert: UnifiedSidePattern equals: pattern class.
	self assert: Color green equals: pattern color.! !

!SidePatternTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2011 13:46'!
testVerticallyParallel

	| pattern |
	pocketCubeSide := PocketCubeSide upperLeftPiece: Color blue upperRightPiece: Color red lowerLeftPiece: Color blue lowerRightPiece: Color red.
	pattern := pocketCubeSide sidePattern.
	self assert: VerticallyParallelSidePattern equals: pattern class.
	self assert: Color blue equals: pattern colorOfLeftBar.
	self assert: Color red equals: pattern colorOfRightBar.

! !
